%%%
%%% common environment variables
%%%

functor

import
   OS(getEnv uName getpwnam) Property(get)

   Internet(display) at
   'x-ozlib://mathweb/share/Internet.ozf'
   
export
   ostype:     OSTYPE
   host:       HOST
   user:       USER
   home:       HOME
   display:    DISPLAY
  
define
  
   OSTYPE = {Property.get 'platform.os'}
   
   HOST = {OS.uName}.nodename
      
   USER = case OSTYPE
          of win32 then {OS.getEnv "USERNAME"}
          else          {OS.getEnv "USER"}
          end
   
   HOME = case OSTYPE
          of win32 then
             case {OS.getEnv "HOMEDRIVE"} of false then false
             [] HOMEDRIVE then
                case {OS.getEnv "HOMEPATH"} of false then false
                [] HOMEPATH then
                   {VirtualString.toString HOMEDRIVE#HOMEPATH}
                end
             end
          else
             case {OS.getEnv "HOME"} of false then
                try {OS.getpwnam USER}.dir
                catch _ then false end
                %% e.g. system(system(limitExternal...)...) for win32
             elseof H then H end
          end

   DISPLAY = case OSTYPE
             of win32 then false
             else Internet.display %{OS.getEnv "DISPLAY"}
             end
   
end








