%%
%% localize a URL
%%

functor
   
import
   Error Resolve OS %System
   
   HTTPClient at 'x-ozlib://mesaros/net/HTTPClient.ozf'
   
   File(loadBS:LoadBS)
   at 'x-ozlib://mathweb/share/File.ozf'
   
export
   url: LoadURL1
   
   builtin: LoadURL1
   mesaros: LoadURL2
   
define
   
   VS2S  = VirtualString.toString

   proc {WatchDog Val Timeout Exc}
      T = {Thread.this} in
      thread
         {WaitOr Val {Alarm Timeout}}
         if {IsFree Val} then
            {Thread.injectException T Exc}
         end
      end
   end
   
   %% version 1: download a URL using builtins
   proc {LoadURL1 U ?BS}
      {WatchDog BS 10000 timeout(10 s)}
      try
         try
            case {Resolve.localize U}
            of old(F) then BS={LoadBS F}
            [] new(F) then BS={LoadBS F} {OS.unlink F}
            end
         catch error(url(localize...)...) then
            BS=false
         end
      catch _ then
         try BS=false
         catch _ then skip end
      end
   end
   
   %% version 2: download a URL using HttpClient.urlGET
   %% http://www.mozart-oz.org/mogul/doc/mesaros/httpclient/exmpl2.oz
   proc {LoadURL2 U ?BS}
      {WatchDog BS 10000 timeout(10 s)}
      Tmp = {OS.tmpnam}
      InParams = inPrms(file:Tmp)
                        %proxySrv:"www-proxy.uni-saarland.de" proxyPort:3128)
      OutParams
      HTTPResponseParams
      Client = {New HTTPClient.urlGET init(InParams _)}
   in
      try
         try
            %%{System.printError "Trying "#{VS2S U}#" ... "}
            {Client getService({VS2S U} ?OutParams ?HTTPResponseParams)}
            %%{System.showError OutParams.status}
            if {String.isInt OutParams.status} andthen
               (({StringToInt OutParams.status} div 100) == 2) then
               BS={LoadBS Tmp}
            else
               BS=false
            end
         catch Err then
            BS=false
            {Error.printException Err}
         finally
            try {OS.unlink Tmp}
            catch _ then skip end
         end
      catch _ then
         try BS=false
         catch _ then skip end
      end
   end
end
