%%
%% ticket analysis
%%

functor

import
   URL
   
export
   analyze: AnalyzeTicket
   
define
   
   proc {ReadTillColon S ?S1 ?S2}
      case S of nil then
         raise ticket(authority "unexpected end of string") end
      [] C|Sr then
         if C == &:
         then S1=nil S2=Sr
         else S1=C|{ReadTillColon Sr $ ?S2}
         end
      end
   end
   
   proc {SplitAuthority AuthorityS ?HostS ?PortI}
      PortS = {ReadTillColon {ReadTillColon AuthorityS ?HostS} $ _}
   in
      if {String.isInt PortS}
      then PortI = {String.toInt PortS}
      else raise ticket(port "integer expected" got:PortS) end
      end
   end
   
   fun {AnalyzeTicket Ticket}
      TicketUrl Host Port in
      try TicketUrl = {URL.make Ticket}
      catch _ then
         raise ticket(url "format error") end
      end
      if TicketUrl.scheme=="x-ozticket"
      then {SplitAuthority TicketUrl.authority ?Host ?Port}
      else raise ticket(scheme "x-ozticket expected" got:TicketUrl.scheme) end
      end
      ticket(host:Host port:Port)
   end
end
