%%
%% generic dialogs
%%

functor

import
   Tk
   TkTools

export
   about      : AboutDialog
   confirm    : ConfirmDialog
   error      : ErrorDialog
   exit       : ExitDialog
   message    : MessageDialog
%   yesNoQuery : YesNoQueryDialog
   
define
   
   %% default value from Configure.oz:
   BigPad = 4
   
   %%
   %% about
   %%
   class AboutDialog from TkTools.dialog
                        
      meth init(master:Master urlGif: UrlGif text:Text)
         TkTools.dialog,tkInit(master:  Master
                               title:   'About'
                               buttons: ['Okay'#tkClose]
                               focus:   1
                               pack:    false
                               default: 1)
         
         Image = {New Tk.image tkInit(type  : photo
                                      format: gif
                                      url   : UrlGif)}
         
         Logo = {New Tk.label tkInit(parent: self
                                     image : Image)}
      
         Author = {New Tk.label tkInit(parent: self
                                       text  : Text)}
      in
         {Tk.send pack(Logo Author side:top)}
         AboutDialog,tkPack
      end
   end
   
   %%
   %% confirm
   %%
   class ConfirmDialog from TkTools.dialog
         
      meth init(master: Master
                aspect: Aspect
                title:  Title <= 'Confirmation'
                text:   Text
                result: ?Result
                padx:   PadX <= BigPad
                pady:   PadY <= BigPad)
         
         proc {Yes}
            Result = true
            {self tkClose}
         end
         
         proc {No}
            Result = false
            {self tkClose}
         end
         
         TkTools.dialog,tkInit(master:  Master
                               title:   Title   
                               buttons: ['Yes'#Yes 'No'#No]
                               focus:   1
                               pack:    false
                               default: 1)
         
         Message = {New Tk.message tkInit(parent: self
                                          aspect: Aspect
                                          text:   Text)}  
      in
         {Tk.send pack(Message side:left expand:1 padx:PadX pady:PadY)}
         ConfirmDialog,tkPack
      end    
   end
   
   %%
   %% exit
   %%
   class ExitDialog from ConfirmDialog

      meth init(title:Title<='Exit'...) = Init
         ConfirmDialog, {AdjoinAt Init title Title}
      end      
   end

   %%
   %% message
   %%
   class MessageDialog from TkTools.dialog
			  
      meth init(master: Master
		aspect: Aspect
                title:  Title <= 'Message'
                text:   Text
                padx:   PadX <= BigPad
                pady:   PadY <= BigPad)
         
	 TkTools.dialog,tkInit(master:  Master
                               title:   Title
			       buttons: ['Okay'#tkClose]
			       focus:   1
                               pack:    false
                               default: 1)
	 
         Message = {New Tk.message tkInit(parent: self
                                          aspect: Aspect
                                          text:   Text)}  
      in
         {Tk.send pack(Message side:left expand:1 padx:PadX pady:PadY)}
         MessageDialog,tkPack
      end    
   end

   %%
   %% error
   %%
   class ErrorDialog from MessageDialog
         
      meth init(title:Title<='Error'...) = Init
         MessageDialog, {AdjoinAt Init title Title}
      end
   end

   /*
   %%
   %% yes/no
   %%
   class YesNoQueryDialog
      from TkTools.dialog
         
      feat
         tkClosed
         queryVar
         
      meth init(master: Master
                bool  : ?Bool)
         
         proc {Okay}
            Selected = {self.queryVar tkReturn($)}
         in
            {self close}
            Bool = Selected
         end
         
         TkTools.dialog,tkInit(master: Master
                               title:  'YesNo Query'
                               buttons: ['Okay' # Okay]
                               focus:   1
                               pack:    false
                               default: 1)
         
         QueryTextFrame = {New TkTools.textframe
                           tkInit(parent: self
                                  text  : 'Decision')}
         
         QueryVar = {New Tk.variable tkInit('T')}
      in
         self.queryVar = QueryVar
         
         {Tk.batch [pack({New Tk.radiobutton
                          tkInit(parent:   QueryTextFrame.inner
                                 value:    'T'
                                 variable: QueryVar
                                 text:     'Yes')}
                         {New Tk.frame tkInit(parent: QueryTextFrame.inner
                                              width : 20)}
                         {New Tk.radiobutton
                          tkInit(parent:   QueryTextFrame.inner
                                 value:    'NIL'
                                 variable: QueryVar
                                 text:     'No')}
                         
                         side:left pady:BigPad)
                    pack(QueryTextFrame)]}
         
         YesNoQueryDialog,tkPack
      end
      
      meth close
         YesNoQueryDialog,tkClose
         self.tkClosed = unit
      end      
   end
   */
end













