%%
%% test program for Base64.decode
%%

functor

import
   Application(getCmdArgs exit)
   System(show printInfo showInfo showError)
   Base64 at 'x-ozlib://mathweb/share/base64.so{native}'
   Slow   at 'x-ozlib://mathweb/share/Base64.ozf'
   
define
   AppName = 'test'
   Spec    = record(mode(single type:atom(encode decode all) default:all)
                    encode(char:&e      alias:mode#encode)
                    decode(char:[&d &u] alias:mode#decode))
   Args
   try
      Args = {Application.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end
   
   proc {TestEncode VS}
      TestVS EncodedVS in
      {System.showInfo "Testing Base64.encode ..."}
      TestVS = {ByteString.make VS}
      {System.printInfo "Input:            "}
      {System.show TestVS}
      EncodedVS = {Base64.encode TestVS}
      {System.printInfo "This result:      "}
      {System.show EncodedVS}
      {System.printInfo "Reference result: "}
      {System.show {ByteString.make {Slow.encode TestVS}}}
      {System.showInfo "... testing Base64.encode done."} 
   end
   proc {TestDecode VS}
      TestVS DecodedVS in
      {System.showInfo "Testing Base64.decode ..."}
      TestVS = {ByteString.make VS}
      {System.printInfo "Input: "}{System.show TestVS}
      DecodedVS = {Base64.decode TestVS}
      {System.printInfo "Result:           "}
      {System.show DecodedVS}
      {System.printInfo "Reference result: "}
      {System.show {ByteString.make {Slow.decode TestVS}}}
      {System.showInfo "... testing Base64.decode done."} 
   end

   {Wait Base64}
   {System.show Base64}
   
   if Args.mode\=decode then
      case Args.1 of nil then
         {TestEncode "a"}
         {TestEncode "ab"}
         {TestEncode "abc"}
         {TestEncode "abcd"}
         {TestEncode "joe:eoj"}
         {TestEncode "12345678:87654321"}
      [] Strings then
         {ForAll Strings TestEncode}
      end
   end
   if Args.mode\=encode then
      case Args.1 of nil then
         {TestDecode "YQ=="}
         {TestDecode "YWI="}
         {TestDecode "YWJj"}
         {TestDecode "YWJjZA=="}
         {TestDecode "am9lOmVvag=="}
         {TestDecode "MTIzNDU2Nzg6ODc2NTQzMjE="}
      [] Strings then
         {ForAll Strings TestDecode}
      end
   end
   {Application.exit 0}
end
