%%
%% benchmark
%%

functor

import
   Application Compiler Error /*Module*/ Open OPIEnv System

   Benchmark(loop2:  Test
             pprint: PPrint)
   at 'x-ozlib://mathweb/share/Benchmark.ozf'
   
define
   AppName = 'benchmark'
   
   Spec = record(times(single char:&n type:int(min:1) default:10000)
                 group(single char:&g type:int(min:1) default:1)
                 repeat(single char:&r type:int(min:1) default:10)
                 
                 copy(single type:bool default:false)
                 propagate(single type:bool default:false)
                 idle(single type:bool default:false)
                 gc(single type:bool default:true)
                 run(single type:bool default:true)
                 system(single type:bool default:true)
                 user(single type:bool default:true)
                 total(single type:bool default:true)
                 all(single alias:[copy#true propagate#true idle#true])
                )
   Args
   try
      Args={Application.getArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end

   Inner     = Args.group
   TotalReps = Args.repeat
   Outer
   if (TotalReps mod Inner) \= 0 then
      {System.showError TotalReps#" is not divisible by "#Inner}
      {Application.exit 1}
   else
      Outer = TotalReps div Inner
   end

   Features = {Filter [copy propagate idle gc run system user total]
               fun {$ F} Args.F end}

   proc {DefaultProc _} skip end

   proc {DoBenchmark Proc}
      ResultRec = {Test Args.times Proc Inner Outer} in
      {System.printInfo {PPrint ResultRec Features}} 
   end

   fun {IsSuffix L1 L2}
      {List.isPrefix {Reverse L1} {Reverse L2}}
   end
in
   case Args.1 of nil then
      {DoBenchmark DefaultProc}
   [] DirectArgs then
      {ForAll DirectArgs
       proc {$ X}
          {System.showInfo ''}
          {System.showInfo X}
          Url = if {IsSuffix ".oz" X} then X
                else X#".oz" end
       in
          try
             ProcSrc
             local
                F = {New Open.file init(url:Url)} in
                {F read(size:all list:?ProcSrc)}
                {F close}
             end
          in
             try 
                Env = {Adjoin OPIEnv.full env('Show':  System.show
                                              'Print': System.print)}
                Proc1 = {Compiler.evalExpression ProcSrc Env _}
             in
                if {IsProcedure Proc1} andthen
                   {Procedure.arity Proc1} == 1
                then
                   try {DoBenchmark Proc1}
                   catch Err then {Error.printException Err} end
                else
                   {System.showError "\n*** Value is not a Procedure/1"}
                end
             catch Err then
                {System.showError "\n*** Could not compile Url/File `"#Url#"'"}
                {Error.printException Err}
             end
          catch Err then
             {System.showError "\n*** Could not read Url/File `"#Url#"'"}
             {Error.printException Err}
          end   
          /*
          case {String.tokens X &#} of [Url Feat] then
             F = {StringToAtom Feat} in
             try
                [Functor]={Module.link [Url]} in
                if {HasFeature Functor F} then
                   Proc = Functor.F in
                   if {IsProcedure Proc} andthen
                      {Procedure.arity Proc} == 1
                   then
                      try {DoBenchmark Proc}
                      catch Err then {Error.printException Err} end
                   else
                      {System.showError "\n*** Value is not a Procedure/1"}
                   end
                else
                   {System.showError "\n*** Feature '"#F#"' not found"}
                end
             catch _ then
                {System.showError "\n*** Could not link functor at `"#Url#"'"}
             end
          else
             {System.showError "\n*** Could not split "#X#' into "Url#Feature"'}
          end
          */
       end}
   end
   {Application.exit 0}
end






